--- avail.c	2011-03-24 14:35:49.000000000 +0000
+++ avail.new.c	2011-03-24 14:36:16.000000000 +0000
@@ -2170,6 +2170,16 @@
 	int host_downtime_depth=0;
 	int service_downtime_depth=0;
 	int process_chunk=FALSE;
+	struct tm *t;
+	unsigned long midnight_today;
+	int weekday;
+	timerange *temp_timerange;
+	unsigned long temp_duration;
+	unsigned long temp_end;
+	unsigned long temp_start;
+	unsigned long start;
+	unsigned long end;
+	
 
 #ifdef DEBUG2
 	printf("COMPUTE_SUBJECT_DOWNTIME\n");
@@ -2232,21 +2242,78 @@
 			start_time=temp_sd->time_stamp;
 			end_time=(temp_sd->next==NULL)?current_time:temp_sd->next->time_stamp;
 
-			/* check time sanity */
-			if(end_time<=t1)
-				continue;
-			if(start_time>=t2)
-				continue;
-			if(start_time>=end_time)
-				continue;
+			/* Jonc edit */
+#ifdef DEBUG
+			printf("REPORT PERIOD=%s <br>\n", url_encode(current_timeperiod->name));
+#endif
+
+	                t=localtime(&start_time);
 
-			/* clip time values */
-			if(start_time<t1)
-				start_time=t1;
-			if(end_time>t2)
-				end_time=t2;
+       		        /* calculate the start of the day (midnight, 00:00 hours) */
+               		t->tm_sec=0;
+                	t->tm_min=0;
+                	t->tm_hour=0;
+                	t->tm_isdst=-1;
+			/* Get the start (midnight) of the day in which this downtime period starts */
+			/* Get the day of the week, so can check timeperiod settings */
+                	midnight_today=(unsigned long)mktime(t);
+                	weekday=t->tm_wday;
 
-			compute_subject_downtime_times(start_time,end_time,subject,temp_sd);
+#ifdef DEBUG
+			printf("weekday %d midnight_today %d <br>", weekday, midnight_today);
+#endif
+
+			/* Need to work out the start and end times of the downtime.. */
+			while(midnight_today<end_time){
+                        	temp_duration=0;
+                        	temp_end=min(86400,end_time-midnight_today);
+                        	temp_start=0;
+
+                        	if(start_time>midnight_today)
+                               		temp_start=start_time-midnight_today;
+
+#ifdef DEBUG
+                        	printf("<b>Matching: %ld -> %ld. (%ld -> %ld)</b><br>\n",temp_start, temp_end, midnight_today+temp_start, midnight_today+temp_end);
+#endif
+
+                        	/* check all time ranges for this day of the week */
+                        	for(temp_timerange=current_timeperiod->days[weekday];temp_timerange!=NULL;temp_timerange=temp_timerange->next){
+			
+#ifdef DEBUG
+                               		printf("<li>Matching in timerange[%d]: %d -> %d (%ld -> %ld)<br>\n",weekday,temp_timerange->range_start,temp_timerange->range_end,temp_start,temp_end);
+#endif
+                               		start=max(temp_timerange->range_start,temp_start);
+                               		end=min(temp_timerange->range_end,temp_end);
+		
+                               		if(start<end){
+                                     		temp_duration+=end-start;
+#ifdef DEBUG
+                                       		printf("<li>Matched time: %ld -> %ld = %d<br>\n",start, end, temp_duration);
+#endif
+				                /* check time sanity */
+                                        	if(end_time<=t1)
+                                                	continue;
+                                        	if(start_time>=t2)
+                                                	continue;
+                                        	if(start_time>=end_time)
+                                                	continue;
+
+						/* clip time values */
+						if(start_time<t1)
+							start_time=t1;
+						if(end_time>t2)
+							end_time=t2;
+
+						compute_subject_downtime_times(start_time,end_time,subject,temp_sd);
+
+                                       		}
+                               		}
+                       			/* state_duration+=temp_duration; */
+                       			temp_start=0;
+                       			midnight_today+=86400;
+                       			if(++weekday>6)
+                               			weekday=0;
+				}
 		        }
 	        }
 
@@ -4582,7 +4649,7 @@
 
 			printf(" TIME_OK_SCHEDULED, PERCENT_TIME_OK_SCHEDULED, PERCENT_KNOWN_TIME_OK_SCHEDULED, TIME_OK_UNSCHEDULED, PERCENT_TIME_OK_UNSCHEDULED, PERCENT_KNOWN_TIME_OK_UNSCHEDULED, TOTAL_TIME_OK, PERCENT_TOTAL_TIME_OK, PERCENT_KNOWN_TIME_OK,");
 
-			printf(" TIME_WARNING_SCHEDULED, PERCENT_TIME_WARNING_SCHEDULED, PERCENT_KNOWN_TIME_WARNING_SCHEDULED, TIME_WARNING_UNSCHEDULED, PERCENT_TIME_WARNING_UNSCHEDULED, PERCENT_KNOWN_TIME_WARNING_UNSCHEDULED, TOTAL_TIME_WARNING, PERCENT_TOTAL_TIME_WARNING, PERCENT_KNOWN_TIME_WARNING,TRUE,");
+			printf(" TIME_WARNING_SCHEDULED, PERCENT_TIME_WARNING_SCHEDULED, PERCENT_KNOWN_TIME_WARNING_SCHEDULED, TIME_WARNING_UNSCHEDULED, PERCENT_TIME_WARNING_UNSCHEDULED, PERCENT_KNOWN_TIME_WARNING_UNSCHEDULED, TOTAL_TIME_WARNING, PERCENT_TOTAL_TIME_WARNING, PERCENT_KNOWN_TIME_WARNING,");
 
 			printf(" TIME_UNKNOWN_SCHEDULED, PERCENT_TIME_UNKNOWN_SCHEDULED, PERCENT_KNOWN_TIME_UNKNOWN_SCHEDULED, TIME_UNKNOWN_UNSCHEDULED, PERCENT_TIME_UNKNOWN_UNSCHEDULED, PERCENT_KNOWN_TIME_UNKNOWN_UNSCHEDULED, TOTAL_TIME_UNKNOWN, PERCENT_TOTAL_TIME_UNKNOWN, PERCENT_KNOWN_TIME_UNKNOWN,");
 
